; copyright: Stephan Bartl working at gk-medizinmechanik.at, 1st version on October 8th, 2014
; script name: XYAHK_customInlineRenameKeys
; version 0.006
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#Persistent
#SingleInstance force
SetTitleMatchMode, 2
SetKeyDelay, 0
SetMouseDelay, 0
titleMatchStringForXY := "XYplorer ahk_class ThunderRT6FormDC"
clicks := mouseX1 := mouseY1 := 0

;code for mapping the double click based on http://www.autohotkey.com/board/topic/16321-map-a-double-left-mouse-click-to-a-single-key/?p=105959 by user jonny 
#if (editNNHavingFocus := _XYOneOfEditNNsHasFocus("Edit15|Edit17|Edit18|Edit19", titleMatchStringForXY)) and clicks = 0
~LButton::
CoordMode, Mouse, Window
MouseGetPos, mouseX1, mouseY1
clicks := 1
SetTimer, ClickWait, 400
return

#if (editNNHavingFocus := _XYOneOfEditNNsHasFocus("Edit15|Edit17|Edit18|Edit19", titleMatchStringForXY)) and clicks > 0
LButton::
CoordMode, Mouse, Window
clicks++
if (clicks = 2)
{
	MouseGetPos, mouseX2, mouseY2
	if (mouseX1 = mouseX2 and mouseY1 = mouseY2)
	{
		ControlGetText, textOfEdit, %editNNHavingFocus%, %titleMatchStringForXY%
		caretPos := _Edit_CaretGetPos(editNNHavingFocus, titleMatchStringForXY)
		selectFromPos := 0
		selectToPos := caretPos
		Loop, parse, textOfEdit
		{
			if (A_Index <= caretPos)
			{
				if A_LoopField is not alnum
					selectFromPos := A_Index
			}
			else if (A_Index > caretPos)
				if A_LoopField is alnum
					selectToPos++
				else
					break
		}
		_Edit_Select(selectFromPos, selectToPos, editNNHavingFocus, titleMatchStringForXY)
	}
	else
	{
		SetTimer, ClickWait, off
		clicks := 0
	}
}
else if (clicks = 3)
{
	MouseGetPos, mouseX3, mouseY3
	if (mouseX3 = mouseX2 and mouseY3 = mouseY2)
	{
		_Edit_Select(0, -1, editNNHavingFocus, titleMatchStringForXY)
	}
	else
	{
		SetTimer, ClickWait, off
		clicks := 0
	}
}
return

ClickWait:
SetTimer, ClickWait, off
clicks := 0
return

#if editNNHavingFocus := _XYOneOfEditNNsHasFocus("Edit15|Edit17|Edit18|Edit19", titleMatchStringForXY)
F2::
ControlGetText, textOfEdit, %editNNHavingFocus%, %titleMatchStringForXY%
_Edit_GetSelection(selStart, selEnd, editNNHavingFocus, titleMatchStringForXY)
lengthOfBase := _lengthOfBase(textOfEdit)
lengthOfText := StrLen(textOfEdit)
if (selStart = 0 and selEnd = lengthOfBase)
	_Edit_Select(lengthOfBase + 1, lengthOfText, editNNHavingFocus, titleMatchStringForXY)
else if (selStart = lengthOfBase + 1 and selEnd = lengthOfText)
	_Edit_Select(0, lengthOfText, editNNHavingFocus, titleMatchStringForXY)
else
	_Edit_Select(0, lengthOfBase, editNNHavingFocus, titleMatchStringForXY)
return

Up::
Down::
if (A_ThisHotkey = "Up")
	upOrDown := "{Up}"
else
	upOrDown := "{Down}"
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
	_Edit_Select(-1, 0, editNNHavingFocus, titleMatchStringForXY)
caretPos := _Edit_CaretGetPos(editNNHavingFocus, titleMatchStringForXY)
ControlGetText, textOfEdit, %editNNHavingFocus%, %titleMatchStringForXY%
lengthOfBase := _lengthOfBase(textOfEdit)
if (caretPos >= lengthOfBase)
	caretNextPos := caretPos - lengthOfBase ;offset from "before last dot" into extension
else
	caretNextPos := (caretPos * -1) - 1 ;position from the start but negative for differentiation (minus 1 extra, otherwise it could be 0 and be confused with 0 offset from base)
ControlSend, %editNNHavingFocus%, %upOrDown%, %titleMatchStringForXY%
Sleep, 10
ControlGetText, textOfEdit, %editNNHavingFocus%, %titleMatchStringForXY%
lengthOfBase := _lengthOfBase(textOfEdit)
if (caretNextPos >= 0)
	_Edit_CaretMoveToPos(lengthOfBase + caretNextPos, editNNHavingFocus, titleMatchStringForXY)
else
	if (Abs(caretNextPos + 1) > lengthOfBase)
		_Edit_CaretMoveToPos(lengthOfBase, editNNHavingFocus, titleMatchStringForXY)
return

Left::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
	ControlSend, %editNNHavingFocus%, {Right}{Left}, %titleMatchStringForXY%
else
	ControlSend, %editNNHavingFocus%, {Left}, %titleMatchStringForXY%
return

Right::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
	ControlSend, %editNNHavingFocus%, {Right}{Right}, %titleMatchStringForXY%
else
	ControlSend, %editNNHavingFocus%, {Right}, %titleMatchStringForXY%
return

End::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
	ControlSend, %editNNHavingFocus%, {Right}, %titleMatchStringForXY%
else
{
	ControlGetText, textOfEdit, %editNNHavingFocus%, %titleMatchStringForXY%
	curColOfCaret := _Edit_CaretGetPos(editNNHavingFocus, titleMatchStringForXY)
	if (curColOfCaret < _lengthOfBase(textOfEdit) or curColOfCaret = StrLen(textOfEdit)) ;if caret at end of text
		_moveCaretToEndOfBase(editNNHavingFocus, titleMatchStringForXY)
	else
		ControlSend, %editNNHavingFocus%, {End}, %titleMatchStringForXY%
}
return

+End::
Critical
ControlGetText, textOfEdit, %editNNHavingFocus%, %titleMatchStringForXY%
curColOfCaret := _Edit_CaretGetPos(editNNHavingFocus, titleMatchStringForXY)
if (curColOfCaret < _lengthOfBase(textOfEdit) or curColOfCaret = StrLen(textOfEdit)) ;if caret at end of text
	_Edit_SelectFromCurPos(_lengthOfBase(textOfEdit), editNNHavingFocus, titleMatchStringForXY)
else
	_Edit_SelectFromCurPos(StrLen(textOfEdit), editNNHavingFocus, titleMatchStringForXY)
return

Home::
ControlGet, selectedText, Selected, , %editNNHavingFocus%, %titleMatchStringForXY%
if (selectedText)
	ControlSend, %editNNHavingFocus%, {Left}, %titleMatchStringForXY%
else
{
	ControlSend, %editNNHavingFocus%, {Home}, %titleMatchStringForXY%
}
return

+Home::
Critical
_Edit_SelectFromCurPos(0, editNNHavingFocus, titleMatchStringForXY)
return
#if

_XYOneOfEditNNsHasFocus(listOfEditNNs, wintitle)
{
   ; This script retrieves the ahk_id (HWND) of the active window's focused control. - taken from the ahk help file
	GuiThreadInfoSize = 48
	VarSetCapacity(GuiThreadInfo, GuiThreadInfoSize)
	NumPut(GuiThreadInfoSize, GuiThreadInfo, 0)
	if not DllCall("GetGUIThreadInfo", uint, 0, str, GuiThreadInfo)
	{
		focusedHWND := 0
	}
	else
		focusedHWND := NumGet(GuiThreadInfo, 12)  ; Retrieve the hwndFocus field from the struct.
	
	returnValue := 0
	Loop, parse, listOfEditNNs, |
	{
		ControlGet, hEdit, hwnd, , %A_LoopField%, %wintitle%
		if (hEdit = focusedHWND)
			returnValue := A_LoopField
	}
	return returnValue
}

_moveCaretToEndOfBase(editNNHavingFocus, wintitle)
{
	ControlGetText, textOfEdit, %editNNHavingFocus%, %wintitle%
	_Edit_CaretMoveToPos(_lengthOfBase(textOfEdit), editNNHavingFocus, wintitle)
}

_moveCaretToHomeOfExtension(editNNHavingFocus, wintitle)
{
	ControlGetText, textOfEdit, %editNNHavingFocus%, %wintitle%
	_Edit_CaretMoveToPos(_lengthOfBase(textOfEdit) + 1, editNNHavingFocus, wintitle)
}

_caretInExtension(editNNHavingFocus, wintitle)
{
	ControlGetText, textOfEdit, %editNNHavingFocus%, %wintitle%
	curColOfCaret := _Edit_CaretGetPos(editNNHavingFocus, wintitle)
	return curColOfCaret > _lengthOfBase(textOfEdit) ? 1 : 0
}

_lengthOfExtension(fileName)
{
	posOfLastDot := InStr(fileName, ".", , 0)
	return posOfLastDot ? (StrLen(fileName) - posOfLastDot) + 1 : 0
}

_lengthOfBase(fileName)
{
	posOfLastDot := InStr(fileName, ".", , 0)
	return posOfLastDot ? posOfLastDot - 1 : StrLen(fileName)
}

_Edit_CaretMoveToPos(pos, control="", wintitle="")
{
	return _Edit_Select(pos, pos, control, wintitle)
}

; Selects text in an edit box (simulating manual selection), starting at
; the current caret position, given absolute character target position.
;
; selectToPos:      	target character offset (zero-based)
; editNNHavingFocus:	the edit control in the form of EditNN
; wintitle:				self explanatory
; 
; other called function: _Edit_CaretGetPos, _Edit_GetSelection
;
_Edit_SelectFromCurPos(selectToPos, editNNHavingFocus, wintitle)
{
	curCaretPos := _Edit_CaretGetPos(editNNHavingFocus, wintitle)
	_Edit_GetSelection(selStart, selEnd, editNNHavingFocus, wintitle)
	if (selStart > selEnd) ;according to my tests not happening in XYplorer, but better be safe than sorry
	{
		tmp := selStart
		selStart := selEnd
		selEnd := tmp
	}
	
	selectRightFromPos := ""
	if (selectToPos >= selEnd) ;for sure selection towards the right
	{
		selectRightFromPos := selEnd ;assumption: current selection substracted
		if (curCaretPos = selEnd) ;check if current selection is added instead
			selectRightFromPos := selStart
	}
	else if (selectToPos >= selStart and curCaretPos = selEnd) ;if target is in the middle of current selection ...
		selectRightFromPos := selStart ;...then it can only result into a caret-to-right-selection if caret is/was at end
	
	if (selectRightFromPos != "")
		_Edit_Select(selectRightFromPos, selectToPos, editNNHavingFocus, wintitle)
	else
		while (curCaretPos != selectToPos)
		{
			selectionLength := selectToPos - curCaretPos
			selectionSendString := "{Shift Down}"
			if (selectToPos = 0)
				selectionSendString := selectionSendString . "{Home}"
			else if (selectionLength < 0)
			{
				selectionLength := Abs(selectionLength)
				Loop, %selectionLength%
				{
					selectionSendString := selectionSendString . "{Left}"
				}
			}
			else
			{
				Loop, %selectionLength%
				{
					selectionSendString := selectionSendString . "{Right}"
				}
			}
			selectionSendString := selectionSendString . "{Shift Up}"
			caretX := A_CaretX
			orgValueSKD := A_KeyDelay
			SetKeyDelay, -1
			BlockInput, Send
			ControlGetFocus, focusedControl, %wintitle%
			if (focusedControl = editNNHavingFocus)
				Send, %selectionSendString%
			else
				return
			BlockInput, Default
			SetKeyDelay, %orgValueSKD%
			while (A_CaretX = caretX)
				Sleep 10
			curCaretPos := _Edit_CaretGetPos(editNNHavingFocus, wintitle)
		}
}

; Gets the current caret position (zero-based) of an edit control having input focus
; (at least for XYplorer inline-edit-controls).
; This function is IMHO preferable over ControlGet, outVar, CurrentCol, ... because
; the build in function is not reliable with the caret position around selections.
;
_Edit_CaretGetPos(editNNHavingFocus, wintitle)
{
	ControlGetFocus, focusedControl, %wintitle%
	if (focusedControl = editNNHavingFocus)
	{
		ControlGet, hEdit, hwnd, , %editNNHavingFocus%, %wintitle%
		ControlGetPos, editX, editY, editW, editH, %editNNHavingFocus%, %wintitle%
		CoordMode, Caret, Window
		_EM_CHARFROMPOS(hEdit, A_CaretX - editX, A_CaretY - editY, charPos, line)
	}
	else
		charPos := ""
	return charPos
}

;***** the following function from http://ahkscript.org/boards/viewtopic.php?f=5&t=4826&p=27883#p27857 by user "just me"
;***** alteration: made the returned index number zero-based
; ======================================================================================================================
; Gets information about the character closest to a specified point in the client area of an edit control.
; X, Y            -  the X- and Y-positions of the point.
; CharPos, Line   -  receive the character position and the line number.
; ======================================================================================================================
_EM_CHARFROMPOS(HWND, X, Y, ByRef CharPos, ByRef Line) {
   ; _EM_CHARFROMPOS = 0x00D7 -> msdn.microsoft.com/en-us/library/bb761566(v=vs.85).aspx
   CharPos := Line := 0
   CharLine := DllCall("User32.dll\SendMessage", "Ptr", HWND, "UInt", 0x00D7, "Ptr", 0, "UInt", (Y << 16) | X, "Ptr")
   CharPos := (CharLine & 0xFFFF)
   Line := (CharLine >> 16)
   Return True
}

;*******following functions from http://www.autohotkey.com/board/topic/20981-edit-control-functions/ by user Lexikos
; Standard parameters:
;   Control, WinTitle   If WinTitle is not specified, 'Control' may be the
;                       unique ID (hwnd) of the control.  If "A" is specified
;                       in Control, the control with input focus is used.
;
; Standard/default return value:
;   true on success, otherwise false.
_Edit_Standard_Params(ByRef Control, ByRef WinTitle) {  ; Helper function.
    if (Control="A" && WinTitle="") { ; Control is "A", use focused control.
        ControlGetFocus, Control, A
        WinTitle = A
    } else if (Control+0!="" && WinTitle="") {  ; Control is numeric, assume its a ahk_id.
        WinTitle := "ahk_id " . Control
        Control =
    }
}

; Gets the start and end offset of the current selection.
;
_Edit_GetSelection(ByRef start, ByRef end, Control="", WinTitle="")
{
    _Edit_Standard_Params(Control, WinTitle)
    VarSetCapacity(start, 4), VarSetCapacity(end, 4)
    SendMessage, 0xB0, &start, &end, %Control%, %WinTitle%  ; EM_GETSEL
    if (ErrorLevel="FAIL")
        return false
    start := NumGet(start), end := NumGet(end)
    return true
}

; Selects text in a text box, given absolute character positions (starting at 0.)
;
; start:    Starting character offset, or -1 to deselect.
; end:      Ending character offset, or -1 for "end of text."
;
_Edit_Select(start=0, end=-1, Control="", WinTitle="")
{
    _Edit_Standard_Params(Control, WinTitle)
    SendMessage, 0xB1, start, end, %Control%, %WinTitle%  ; EM_SETSEL
    return (ErrorLevel != "FAIL")
}